apiVersion: "networking.k8s.io/v1"
kind: "Ingress"
metadata:
  name: {{ include "authorization.fullname" . }}
  labels: {{- include "authorization.labels" . | nindent 4 }}
  annotations:
    kubernetes.io/ingress.class: "traefik"
    traefik.ingress.kubernetes.io/router.middlewares:
      {{ .Release.Namespace }}-{{ include "authorization.fullname" . }}-strip-prefix@kubernetescrd
    {{- if .Values.tls.enabled }}
      ,{{ .Release.Namespace }}-{{ include "authorization.fullname" . }}-https-redirect@kubernetescrd
    cert-manager.io/cluster-issuer: "letsencrypt-{{ .Values.environment }}"
    {{- end }}
spec:
  rules:
    - http:
        paths:
          - backend:
              service:
                name: {{ include "authorization.fullname" . }}
                port:
                  name: "api"
            path: '/{{ include "authorization.name" . }}'
            pathType: "Prefix"
          - backend:
              service:
                name: {{ include "authorization.fullname" . }}
                port:
                  name: "api"
            path: '/api/{{ include "authorization.name" . }}'
            pathType: "Prefix"
  {{- if .Values.tls.enabled }}
  tls:
    - hosts:
        - {{ .Values.tls.hostname }}
      secretName: {{.Values.tls.certSecret }}
  {{- end }}
---
apiVersion: traefik.containo.us/v1alpha1
kind: Middleware
metadata:
  name: {{ include "authorization.fullname" . }}-strip-prefix
spec:
  stripPrefix:
    prefixes:
      - '/{{ include "authorization.name" . }}'
      - '/api/{{ include "authorization.name" . }}'
---
{{- if .Values.tls.enabled }}
apiVersion: traefik.containo.us/v1alpha1
kind: Middleware
metadata:
  name: {{ include "authorization.fullname" . }}-https-redirect
spec:
  redirectScheme:
    scheme: https
    permanent: true
{{- end }}
